
;CodeVisionAVR C Compiler V2.04.0a Standard
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATtiny26L
;Program type             : Application
;Clock frequency          : 16,000000 MHz
;Memory model             : Tiny
;Optimize for             : Speed
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 32 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : No
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Smart register allocation     : Off
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny26L
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E

	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _EtatCdeMot=R4
	.DEF _Position_Robot=R5

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_0x48:
	.DB  0x0,0x0

__GLOBAL_INI_TBL:
	.DW  0x02
	.DW  0x04
	.DW  _0x48*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x80)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80

	.CSEG
;/*************************************************************
;This program was produced by the
;CodeWizardAVR V1.24.0 Standard
;Automatic Program Generator
; Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro
;
;Project : TP Robot suiveur de ligne "Carte MrLineTiny"
;Version : 2
;Date    : 19/03/2009
;Author  : Philippe Mariano
;Company : LYCEE Pierre Emile MARTIN
;Comments: Suivi de ligne (fichier prof)
;
;Fichier : StayOnLp.c
;
;Chip type           : ATtiny26(L)
;Clock frequency     : 16,000000 MHz
;Memory model        : Tiny
;External SRAM size  : 0
;Data Stack size     : 32
;*************************************************************/
;
;#include <tiny26.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_mask=0x18
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x18
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;
;// Boolen
;//-----------------------------------------------------------------------------------------------------
;#define ACO 	ACSR.5  // Sortie du comparateur analogique
;
;// Temporisations
;//-----------------------------------------------------------------------------------------------------
;#define t_IR 	19 	// Dure de la commande d'un E_IR (Del IR)
;#define t_mux 	540    	// Dure entre deux cde d'un E_IR
;#define t_delay 704     // Permet de rgler la priode d'chantillonnage (tech) de la position
;			// du robot par rapport  la ligne tech = 3*(t_IR + t_mux) + t_delay
;
;// Commande des moteurs
;//-----------------------------------------------------------------------------------------------------
;#define CDE_ROUE_G	OCR1A       //   roue gauche
;#define CDE_ROUE_D	OCR1B	    //   roue droite
;
;// Valeurs reprsentatives du rapport cyclique du signal
;// de commande des moteurs (OC1A et OC1B non inverss)
;//-----------------------------------------------------------------------------------------------------
;#define _0PC	 255		 // 0%
;#define _10PC	 230             // 10%
;#define _20PC    204		 // 20%
;#define _30PC    179		 // 30%
;#define _40PC    153		 // 40%
;#define _50PC    128             // 50%
;#define _60PC    102             // 60%
;#define _70PC    77              // 70%
;#define _80PC    51              // 80%
;#define _90PC    26              // 90%
;
;// Connexions des Dels Visu et IR au port A
;//-----------------------------------------------------------------------------------------------------
;// Del_D	relie  PA3 (D1)     E_D_IR	PAO  (DIR1)
;// Del_C 	relie  PA4 (D2)     E_C_IR	PA1  (DIR2)
;// Del_G	relie  PA5 (D3)     E_G_IR	PA2  (DIR3)
;
;// Mots de commande des Dels Visu   (- Del teinte 	* Del claire)
;// ----------------------------------Etat des Dels de visualisation------------------------------------
;             					// Del_G | Del_C | Del_D  VisuPosition(16)     Remarque
;//-----------------------------------------------------------------------------------------------------
;#define Visu_Hors_ligne         0b00111111      // off   | off   | off        3F		- - -
;#define Visu_Droite_Plus        0b00011111      // on    | off   | off 	      1F	        * - -
;#define Visu_Centre1		0b00101111      // off   | on    | off        2F		- * -
;#define Visu_Droite             0b00001111      // on    | on    | off        0F	        * * -
;#define Visu_Gauche_Plus        0b00110111      // off   | off   | on         37		- - *
;#define Visu_Centre2            0b00010111      // on    | off   | on         17	        * - *
;#define Visu_Gauche		0b00100111      // off   | on    | on         27         	- * *
;#define Visu_Centre3            0b00000111      // on    | on    | on         07		* * *
;
;// Prototype des fonctions
;//---------------------------
;void Arret_Moteurs();
;void Active_Timer();
;
;// Variables globales
;//-----------------------------------------------------------------------------------------------------
;// type		nom		Commentaires
;//-----------------------------------------------------------------------------------------------------
;// Les diffrentes commandes des moteurs
;enum Etat_Commande_Moteur {DEPART, CDE_CENTRE1, CDE_CENTRE2, CDE_CENTRE3,
;CDE_DROITE, CDE_DROITE_PLUS, HORS_LIGNE_DROITE, CDE_GAUCHE, CDE_GAUCHE_PLUS, HORS_LIGNE__GAUCHE}
;EtatCdeMot = DEPART;
;
;// Les diffrentes positions du robot par rapport  la ligne
;enum Etat_Position_Robot {HORS_LIGNE, GAUCHE_PLUS , CENTRE_1, GAUCHE,
;DROITE_PLUS, CENTRE_2, DROITE, CENTRE_3} Position_Robot = HORS_LIGNE;
;
;
;//-----------------------------------------------------------------------------------------------------
;// Dbut du programme principal
;//-----------------------------------------------------------------------------------------------------
;void main(void)
; 0000 0064 {

	.CSEG
_main:
; 0000 0065 
; 0000 0066 // Variables locales
; 0000 0067 //-----------------------------------------------------------------------------------------------------
; 0000 0068 // type		nom		Commentaires
; 0000 0069 //-----------------------------------------------------------------------------------------------------
; 0000 006A unsigned char i;                // Compteur de boucles
; 0000 006B unsigned char Cde_Del_IR;	// Permet de multiplexer la commande des dels IR
; 0000 006C unsigned char VisuPosition;	// Affichage de la position du robot sur 3 dels
; 0000 006D 
; 0000 006E // Input/Output Ports initialization
; 0000 006F // Port A initialization
; 0000 0070 // Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=In Func7=In
; 0000 0071 // State0=1 State1=1 State2=1 State3=1 State4=1 State5=1 State6=T State7=T
; 0000 0072 PORTA=0x3F;
;	i -> R16
;	Cde_Del_IR -> R17
;	VisuPosition -> R18
	LDI  R30,LOW(63)
	OUT  0x1B,R30
; 0000 0073 DDRA=0x3F;
	OUT  0x1A,R30
; 0000 0074 
; 0000 0075 // Port B initialization
; 0000 0076 // Func0=In Func1=Out Func2=In Func3=Out Func4=In Func5=In Func6=In Func7=In
; 0000 0077 // State0=T State1=1 State2=T State3=1 State4=T State5=T State6=P State7=T
; 0000 0078 PORTB=0x0A;
	LDI  R30,LOW(10)
	OUT  0x18,R30
; 0000 0079 DDRB=0x0A;
	OUT  0x17,R30
; 0000 007A 
; 0000 007B // Timer/Counter 1 initialization
; 0000 007C // Clock source: System Clock
; 0000 007D // Clock value: 4000,000 kHz (frquence d'entre du timer FQ/4)
; 0000 007E // Mode: PWMA & B top=OCR1C
; 0000 007F // OC1A output: Non-Inv., /OC1A disconnected
; 0000 0080 // OC1B output: Non-Inv., /OC1B disconnected
; 0000 0081 PLLCSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
; 0000 0082 TCCR1A=0xA3;
	LDI  R30,LOW(163)
	OUT  0x30,R30
; 0000 0083 TCCR1B=0x03;
	LDI  R30,LOW(3)
	OUT  0x2F,R30
; 0000 0084 TCNT1=0x00;
	LDI  R30,LOW(0)
	OUT  0x2E,R30
; 0000 0085 OCR1A=0x00;
	OUT  0x2D,R30
; 0000 0086 OCR1B=0x00;
	OUT  0x2C,R30
; 0000 0087 OCR1C=0xFF;
	LDI  R30,LOW(255)
	OUT  0x2B,R30
; 0000 0088 
; 0000 0089 // Analog Comparator initialization
; 0000 008A // Analog Comparator: On
; 0000 008B ACSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x8,R30
; 0000 008C 
; 0000 008D PORTA = 0x3F;   // Extinction des Dels
	LDI  R30,LOW(63)
	OUT  0x1B,R30
; 0000 008E 
; 0000 008F while (1)
_0x3:
; 0000 0090     {// dbut while
; 0000 0091       Position_Robot =  HORS_LIGNE;   // Initialisation
	CLR  R5
; 0000 0092       Cde_Del_IR = 1;
	LDI  R17,LOW(1)
; 0000 0093 
; 0000 0094 /*-----------------------------------------------------------------------------------------------------
; 0000 0095 // Dbut de la tche "Acqurir la position du robot par rapport  la ligne" (Intgre dans FS21 et FS35)
; 0000 0096 //-----------------------------------------------------------------------------------------------------
; 0000 0097 FS21 " Commander un des trois metteurs IR(Del)"
; 0000 0098 
; 0000 0099 Rle : Slectionner un des trois metteurs (Del IR) devant gnrer un faisceau IR
; 0000 009A 
; 0000 009B Entre : 	Cde_Del_IR 		octet permettant de multiplexer la commande des dels IR
; 0000 009C 
; 0000 009D Sorties:        PA0, PA1, PA2 		bits de commande des dels IR (dtails ci-dessous)
; 0000 009E 					Emmetteur IR connect  au bit      Remarque
; 0000 009F 					----------------------------------------------------
; 0000 00A0 					E_D_IR		"      PA0    |   Emmeteur IR droit
; 0000 00A1 					E_C_IR		"      PA1    |	  Emmeteur IR centre
; 0000 00A2 					E_G_IR 		"      PA2    |	  Emmeteur IR gauche
; 0000 00A3 //-----------------------------------------------------------------------------------------------------
; 0000 00A4 FS35 "Calculer la position du robot par rapport  la ligne"
; 0000 00A5 
; 0000 00A6 Rle : Etablir une valeur numrique reprsentative de la position du robot par rapport  la ligne
; 0000 00A7 
; 0000 00A8 Entres : 	AC0		 	bit associ  la sortie du comparateur analogique,
; 0000 00A9 					reprsentatif de la position d'un capteur sur la ligne
; 0000 00AA 
; 0000 00AB Sortie :	Position_Robot		octet image de la position du robot par rapport  la ligne)
; 0000 00AC                                         (dtails ci-dessous)
; 0000 00AD 
; 0000 00AE Position des capteurs IR  =>  "Position_Robot"	// Positions du robot par rapport  la ligne
; 0000 00AF //-----------------------------------------------------------------------------------------------------
; 0000 00B0 IR_G  | IR_C  |  IR_D    =>     Position_Robot(10)
; 0000 00B1 non  |  non  |   non     =>	   0		// Hors ligne
; 0000 00B2 non  |  non  |   oui     =>	   1         	// Gauche+
; 0000 00B3 non  |  oui  |   non     =>	   2         	// Centre1 (ligne noire de largeur gale  celle d'un capteur)
; 0000 00B4 non  |  oui  |   oui     =>	   3         	// Gauche
; 0000 00B5 oui  |  non  |   non     =>	   4		// Droite+
; 0000 00B6 oui  |  non  |   oui     =>	   5         	// Centre2 (ligne blanche entoure de deux noires)
; 0000 00B7 oui  |  oui  |   non     =>	   6		// Droite
; 0000 00B8 oui  |  oui  |   oui     =>	   7         	// Centre3 (ligne noire de largeur gale  celle de trois capteurs)
; 0000 00B9 
; 0000 00BA -----------------------------------------------------------------------------------------------------*/
; 0000 00BB       for (i=0;i<3;i++)
	LDI  R16,LOW(0)
_0x7:
	CPI  R16,3
	BRSH _0x8
; 0000 00BC        {
; 0000 00BD         PORTA = ~Cde_Del_IR; 					      // Les E_IR (Leds IR) sont commands  l'tat bas
	MOV  R30,R17
	COM  R30
	OUT  0x1B,R30
; 0000 00BE       	delay_us(t_IR);						      // Dure de l'tat bas (A ajuster en fonction des capteurs)
	__DELAY_USB 101
; 0000 00BF         if (ACO == 1) Position_Robot = Position_Robot | Cde_Del_IR;   // Si le capteur IR_x x=(D,C,G] est sur la ligne
	SBIC 0x8,5
	OR   R5,R17
; 0000 00C0         PORTA = 0x3F;                                                 // le bit correspondant de "Position_Robot est mis  1
	LDI  R30,LOW(63)
	OUT  0x1B,R30
; 0000 00C1         Cde_Del_IR = Cde_Del_IR << 1 ;
	LSL  R17
; 0000 00C2         delay_us(t_mux);					      // Tempo permettant d'attendre l'anulation de la ddp sur
	__DELAY_USW 2160
; 0000 00C3        } 							      // l'entre AIN1 (signal de rception IR) avant une nouvelle
	SUBI R16,-1
	RJMP _0x7
_0x8:
; 0000 00C4         							      // mesure (A ajuster en fonction des capteurs)
; 0000 00C5 
; 0000 00C6 
; 0000 00C7 // Fin de la tche "Acqurir la position du robot par rapport  la ligne" (Fonctions FS21 et FS35)
; 0000 00C8 //-----------------------------------------------------------------------------------------------------
; 0000 00C9 
; 0000 00CA 
; 0000 00CB /*-----------------------------------------------------------------------------------------------------
; 0000 00CC Dbut de la tche  "Traiter l'information "Position_Robot" pour visualiser la position du robot par rapport
; 0000 00CD  la ligne" (Fonction FP1)
; 0000 00CE //-----------------------------------------------------------------------------------------------------
; 0000 00CF Rle :  lorsque le capteur est sur la ligne, la Del correspondante s'claire
; 0000 00D0 
; 0000 00D1 Entre:         Position_Robot      	(voir ci-dessus)
; 0000 00D2 
; 0000 00D3 Sorties:	PortA            	octet
; 0000 00D4  					Del de visualisation connecte au bit
; 0000 00D5 					----------------------------------------
; 0000 00D6 					Del_D       "      		PA3
; 0000 00D7 					Del_C       "	  		PA4
; 0000 00D8 					Del_G       "	  		PA5
; 0000 00D9 					Remarque : D pour droite, C pour centre, G pour gauche
; 0000 00DA -----------------------------------------------------------------------------------------------------*/
; 0000 00DB 
; 0000 00DC       switch (Position_Robot)              	       		// Etat des Dels de visualisation
	MOV  R30,R5
; 0000 00DD        {                                   	       		// Del_G | Del_C | Del_D
; 0000 00DE         case 0: VisuPosition = Visu_Hors_ligne; break; 		// off   | off   | off
	CPI  R30,0
	BRNE _0xD
	LDI  R18,LOW(63)
	RJMP _0xC
; 0000 00DF         case 1: VisuPosition = Visu_Gauche_Plus; break; 	// off   | off   | on
_0xD:
	CPI  R30,LOW(0x1)
	BRNE _0xE
	LDI  R18,LOW(55)
	RJMP _0xC
; 0000 00E0         case 2: VisuPosition = Visu_Centre1; break; 		// off   | on    | off
_0xE:
	CPI  R30,LOW(0x2)
	BRNE _0xF
	LDI  R18,LOW(47)
	RJMP _0xC
; 0000 00E1         case 3: VisuPosition = Visu_Gauche; break;     		// off   | on    | on
_0xF:
	CPI  R30,LOW(0x3)
	BRNE _0x10
	LDI  R18,LOW(39)
	RJMP _0xC
; 0000 00E2         case 4: VisuPosition = Visu_Droite_Plus; break; 	// on    | off   | off
_0x10:
	CPI  R30,LOW(0x4)
	BRNE _0x11
	LDI  R18,LOW(31)
	RJMP _0xC
; 0000 00E3         case 5: VisuPosition = Visu_Centre2; break; 		// on    | off   | on
_0x11:
	CPI  R30,LOW(0x5)
	BRNE _0x12
	LDI  R18,LOW(23)
	RJMP _0xC
; 0000 00E4         case 6: VisuPosition = Visu_Droite; break; 		// on    | on    | off
_0x12:
	CPI  R30,LOW(0x6)
	BRNE _0x13
	LDI  R18,LOW(15)
	RJMP _0xC
; 0000 00E5         case 7: VisuPosition = Visu_Centre3; break;      	// on    | on    | on
_0x13:
	CPI  R30,LOW(0x7)
	BRNE _0xC
	LDI  R18,LOW(7)
; 0000 00E6        }
_0xC:
; 0000 00E7 
; 0000 00E8 // Fin de la tche  "Traiter l'information "Position_Robot" pour visualiser la position du robot par
; 0000 00E9 // rapport  la ligne" (Fonction FP1)
; 0000 00EA //-----------------------------------------------------------------------------------------------------
; 0000 00EB 
; 0000 00EC 
; 0000 00ED        PORTA = VisuPosition;  // Fonction FS61 "Slectionner les dels de visualisation"
	OUT  0x1B,R18
; 0000 00EE 
; 0000 00EF /*-----------------------------------------------------------------------------------------------------
; 0000 00F0 Dbut de la tche  "Traiter l'information "Position_Robot" pour corriger la trajectoire du robot"
; 0000 00F1 (Fonction FP1)
; 0000 00F2 //-----------------------------------------------------------------------------------------------------
; 0000 00F3 Rle: Rgler le rapport cyclique des signaux de commande des moteurs droit et gauche pour rgler la
; 0000 00F4 trajectoire du robot afin qu'il suive la ligne
; 0000 00F5 
; 0000 00F6 Entre:    Position_Robot             	(voir ci-dessus)
; 0000 00F7 
; 0000 00F8 Sorties:   CDE_ROUE_G         octet	(OCR1A)rgle le rapport cyclique du signal de commande du moteur
; 0000 00F9 					associ  la roue Gauch
; 0000 00FA 	   CDE_ROUE_D                   (OCR1B)rgle le rapport cyclique du signal de commande du moteur
; 0000 00FB 	   associ  la roue Droit
; 0000 00FC -----------------------------------------------------------------------------------------------------*/
; 0000 00FD       switch (EtatCdeMot)
	MOV  R30,R4
; 0000 00FE        { // Dbut switch (EtatCdeMot)
; 0000 00FF         case DEPART: Arret_Moteurs();
	CPI  R30,0
	BRNE _0x18
	RCALL _Arret_Moteurs
; 0000 0100         		if ((Position_Robot == CENTRE_1) || (Position_Robot == CENTRE_2) || (Position_Robot == CENTRE_3))
	LDI  R30,LOW(2)
	CP   R30,R5
	BREQ _0x1A
	LDI  R30,LOW(5)
	CP   R30,R5
	BREQ _0x1A
	LDI  R30,LOW(7)
	CP   R30,R5
	BRNE _0x19
_0x1A:
; 0000 0101         		    {
; 0000 0102         		      delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0103         		      Active_Timer();
	RCALL _Active_Timer
; 0000 0104         		      EtatCdeMot = CDE_CENTRE1;
	LDI  R30,LOW(1)
	MOV  R4,R30
; 0000 0105         		    }
; 0000 0106         		    else  EtatCdeMot = DEPART;
	RJMP _0x1C
_0x19:
	CLR  R4
; 0000 0107         break;
_0x1C:
	RJMP _0x17
; 0000 0108 
; 0000 0109         case CDE_CENTRE1: EtatCdeMot = CDE_CENTRE3;
_0x18:
	CPI  R30,LOW(0x1)
	BRNE _0x1D
	RJMP _0x40
; 0000 010A         break;
; 0000 010B 
; 0000 010C         case CDE_CENTRE2: EtatCdeMot = CDE_CENTRE3;
_0x1D:
	CPI  R30,LOW(0x2)
	BRNE _0x1E
	RJMP _0x40
; 0000 010D 
; 0000 010E         break;
; 0000 010F 
; 0000 0110         case CDE_CENTRE3: CDE_ROUE_G = _60PC; CDE_ROUE_D = _60PC;
_0x1E:
	CPI  R30,LOW(0x3)
	BRNE _0x1F
	LDI  R30,LOW(102)
	OUT  0x2D,R30
	OUT  0x2C,R30
; 0000 0111                           if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
	LDI  R30,LOW(3)
	CP   R30,R5
	BRNE _0x20
	LDI  R30,LOW(4)
	RJMP _0x41
; 0000 0112                           	else if (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
_0x20:
	LDI  R30,LOW(6)
	CP   R30,R5
	BRNE _0x22
	LDI  R30,LOW(7)
	RJMP _0x41
; 0000 0113                           		else EtatCdeMot = CDE_CENTRE3;
_0x22:
	LDI  R30,LOW(3)
_0x41:
	MOV  R4,R30
; 0000 0114         break;
	RJMP _0x17
; 0000 0115 
; 0000 0116         case CDE_DROITE:CDE_ROUE_G = _60PC; CDE_ROUE_D = _50PC;
_0x1F:
	CPI  R30,LOW(0x4)
	BRNE _0x24
	LDI  R30,LOW(102)
	OUT  0x2D,R30
	LDI  R30,LOW(128)
	OUT  0x2C,R30
; 0000 0117                          if (Position_Robot == CENTRE_3) EtatCdeMot = CDE_CENTRE3;
	LDI  R30,LOW(7)
	CP   R30,R5
	BRNE _0x25
	LDI  R30,LOW(3)
	RJMP _0x42
; 0000 0118                           	else if (Position_Robot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS;
_0x25:
	LDI  R30,LOW(1)
	CP   R30,R5
	BRNE _0x27
	LDI  R30,LOW(5)
	RJMP _0x42
; 0000 0119                           		else EtatCdeMot = CDE_DROITE;
_0x27:
	LDI  R30,LOW(4)
_0x42:
	MOV  R4,R30
; 0000 011A         break;
	RJMP _0x17
; 0000 011B 
; 0000 011C         case CDE_DROITE_PLUS:CDE_ROUE_G = _60PC; CDE_ROUE_D = _40PC;
_0x24:
	CPI  R30,LOW(0x5)
	BRNE _0x29
	LDI  R30,LOW(102)
	OUT  0x2D,R30
	LDI  R30,LOW(153)
	OUT  0x2C,R30
; 0000 011D         	if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
	LDI  R30,LOW(3)
	CP   R30,R5
	BRNE _0x2A
	LDI  R30,LOW(4)
	RJMP _0x43
; 0000 011E         		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = HORS_LIGNE_DROITE;
_0x2A:
	TST  R5
	BRNE _0x2C
	LDI  R30,LOW(6)
	RJMP _0x43
; 0000 011F                           		else EtatCdeMot = CDE_DROITE_PLUS;
_0x2C:
	LDI  R30,LOW(5)
_0x43:
	MOV  R4,R30
; 0000 0120         break;
	RJMP _0x17
; 0000 0121 
; 0000 0122         case HORS_LIGNE_DROITE:CDE_ROUE_G = _50PC; CDE_ROUE_D = _20PC;
_0x29:
	CPI  R30,LOW(0x6)
	BRNE _0x2E
	LDI  R30,LOW(128)
	OUT  0x2D,R30
	LDI  R30,LOW(204)
	OUT  0x2C,R30
; 0000 0123         	if (Position_Robot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS;
	LDI  R30,LOW(1)
	CP   R30,R5
	BRNE _0x2F
	LDI  R30,LOW(5)
	RJMP _0x44
; 0000 0124                           		else EtatCdeMot = HORS_LIGNE_DROITE;
_0x2F:
	LDI  R30,LOW(6)
_0x44:
	MOV  R4,R30
; 0000 0125         break;
	RJMP _0x17
; 0000 0126 
; 0000 0127         case CDE_GAUCHE: CDE_ROUE_G = _50PC; CDE_ROUE_D = _60PC;
_0x2E:
	CPI  R30,LOW(0x7)
	BRNE _0x31
	LDI  R30,LOW(128)
	OUT  0x2D,R30
	LDI  R30,LOW(102)
	OUT  0x2C,R30
; 0000 0128                        if (Position_Robot == CENTRE_3) EtatCdeMot = CDE_CENTRE3;
	LDI  R30,LOW(7)
	CP   R30,R5
	BRNE _0x32
	LDI  R30,LOW(3)
	RJMP _0x45
; 0000 0129                           	else if (Position_Robot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;
_0x32:
	LDI  R30,LOW(4)
	CP   R30,R5
	BRNE _0x34
	LDI  R30,LOW(8)
	RJMP _0x45
; 0000 012A                           		else EtatCdeMot = CDE_GAUCHE;
_0x34:
	LDI  R30,LOW(7)
_0x45:
	MOV  R4,R30
; 0000 012B         break;
	RJMP _0x17
; 0000 012C 
; 0000 012D         case CDE_GAUCHE_PLUS: CDE_ROUE_G = _40PC; CDE_ROUE_D = _60PC;
_0x31:
	CPI  R30,LOW(0x8)
	BRNE _0x36
	LDI  R30,LOW(153)
	OUT  0x2D,R30
	LDI  R30,LOW(102)
	OUT  0x2C,R30
; 0000 012E                        if (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
	LDI  R30,LOW(6)
	CP   R30,R5
	BRNE _0x37
	LDI  R30,LOW(7)
	RJMP _0x46
; 0000 012F                        		else if (Position_Robot == HORS_LIGNE) EtatCdeMot = HORS_LIGNE__GAUCHE;
_0x37:
	TST  R5
	BRNE _0x39
	LDI  R30,LOW(9)
	RJMP _0x46
; 0000 0130                           		else EtatCdeMot = CDE_GAUCHE_PLUS;
_0x39:
	LDI  R30,LOW(8)
_0x46:
	MOV  R4,R30
; 0000 0131         break;
	RJMP _0x17
; 0000 0132 
; 0000 0133         case HORS_LIGNE__GAUCHE:CDE_ROUE_G = _20PC; CDE_ROUE_D = _50PC;
_0x36:
	CPI  R30,LOW(0x9)
	BRNE _0x3E
	LDI  R30,LOW(204)
	OUT  0x2D,R30
	LDI  R30,LOW(128)
	OUT  0x2C,R30
; 0000 0134         	if (Position_Robot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;
	LDI  R30,LOW(4)
	CP   R30,R5
	BRNE _0x3C
	LDI  R30,LOW(8)
	RJMP _0x47
; 0000 0135                           		else EtatCdeMot = HORS_LIGNE__GAUCHE;
_0x3C:
	LDI  R30,LOW(9)
_0x47:
	MOV  R4,R30
; 0000 0136         break;
	RJMP _0x17
; 0000 0137 
; 0000 0138 
; 0000 0139         default : EtatCdeMot = CDE_CENTRE3;
_0x3E:
_0x40:
	LDI  R30,LOW(3)
	MOV  R4,R30
; 0000 013A 
; 0000 013B        }// Fin switch (EtatCdeMot)
_0x17:
; 0000 013C 
; 0000 013D // Fin de la tche  "Traiter l'information "Position_Robot" pour corriger la trajectoire du robot"
; 0000 013E // (Fonction FP1)
; 0000 013F //-----------------------------------------------------------------------------------------------------
; 0000 0140 
; 0000 0141 	delay_us(t_delay); // A ajuster en fonction de la vitesse du robot
	__DELAY_USW 2816
; 0000 0142 
; 0000 0143     }// fin while(1);
	RJMP _0x3
; 0000 0144 } // fin prog princ
_0x3F:
	RJMP _0x3F
;
;
;
;//-----------------------------------------------------------------------------------------------------
;// Sous-programmes
;//-----------------------------------------------------------------------------------------------------
;void Arret_Moteurs()
; 0000 014C {
_Arret_Moteurs:
; 0000 014D       TCCR1A = 0x00; // Arrt PWM
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 014E       TCCR1B = 0x00;
	OUT  0x2F,R30
; 0000 014F       PORTB=0x0B;     // Arrt Moteur
	LDI  R30,LOW(11)
	OUT  0x18,R30
; 0000 0150 }
	RET
;
;void Active_Timer()
; 0000 0153 {       // Marche PWM
_Active_Timer:
; 0000 0154       	TCCR1A=0xA3;
	LDI  R30,LOW(163)
	OUT  0x30,R30
; 0000 0155 	TCCR1B=0x03;
	LDI  R30,LOW(3)
	OUT  0x2F,R30
; 0000 0156 }
	RET

	.CSEG

	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

;END OF CODE MARKER
__END_OF_CODE:
