
#pragma used+
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSR=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb USICR=0xd;
sfrb USISR=0xe;
sfrb USIDR=0xf;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEAR=0x1e;
sfrb WDTCR=0x21;
sfrb PLLCSR=0x29;
sfrb OCR1C=0x2b;
sfrb OCR1B=0x2c;
sfrb OCR1A=0x2d;
sfrb TCNT1=0x2e;
sfrb TCCR1B=0x2f;
sfrb TCCR1A=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb SP=0x3d;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_mask=0x18
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x18
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

void Arret_Moteurs();
void Active_Timer();

enum Etat_Commande_Moteur {DEPART, CDE_CENTRE1, CDE_CENTRE2, CDE_CENTRE3, 
CDE_DROITE, CDE_DROITE_PLUS, HORS_LIGNE_DROITE, CDE_GAUCHE, CDE_GAUCHE_PLUS, HORS_LIGNE__GAUCHE} 
EtatCdeMot = DEPART;

enum Etat_Position_Robot {HORS_LIGNE, GAUCHE_PLUS , CENTRE_1, GAUCHE, 
DROITE_PLUS, CENTRE_2, DROITE, CENTRE_3} Position_Robot = HORS_LIGNE; 

void main(void)
{

unsigned char i;                
unsigned char Cde_Del_IR;	
unsigned char VisuPosition;	

PORTA=0x3F;
DDRA=0x3F;

PORTB=0x0A;
DDRB=0x0A;

PLLCSR=0x00;
TCCR1A=0xA3;
TCCR1B=0x03;
TCNT1=0x00;
OCR1A=0x00;
OCR1B=0x00;
OCR1C=0xFF;

ACSR=0x00;

PORTA = 0x3F;   

while (1)
{
Position_Robot =  HORS_LIGNE;   
Cde_Del_IR = 1; 

for (i=0;i<3;i++)  
{
PORTA = ~Cde_Del_IR; 					      
delay_us(19 	);						      
if (ACSR.5   == 1) Position_Robot = Position_Robot | Cde_Del_IR;   
PORTA = 0x3F;                                                 
Cde_Del_IR = Cde_Del_IR << 1 ;                                 
delay_us(540    	);					      
} 							      

switch (Position_Robot)              	       		
{                                   	       		
case 0: VisuPosition = 0b00111111      ; break; 		
case 1: VisuPosition = 0b00110111      ; break; 	
case 2: VisuPosition = 0b00101111      ; break; 		
case 3: VisuPosition = 0b00100111      ; break;     		
case 4: VisuPosition = 0b00011111      ; break; 	
case 5: VisuPosition = 0b00010111      ; break; 		
case 6: VisuPosition = 0b00001111      ; break; 		
case 7: VisuPosition = 0b00000111      ; break;      	
}   

PORTA = VisuPosition;  

switch (EtatCdeMot)              
{ 
case DEPART: Arret_Moteurs(); 
if ((Position_Robot == CENTRE_1) || (Position_Robot == CENTRE_2) || (Position_Robot == CENTRE_3))
{ 
delay_ms(3000);
Active_Timer();
EtatCdeMot = CDE_CENTRE1;
}
else  EtatCdeMot = DEPART;
break;   

case CDE_CENTRE1: EtatCdeMot = CDE_CENTRE3; 
break;  

case CDE_CENTRE2: EtatCdeMot = CDE_CENTRE3;   

break;   

case CDE_CENTRE3: OCR1A        = 102             ; OCR1B	     = 102             ;
if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE;
else if (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
else EtatCdeMot = CDE_CENTRE3;
break; 

case CDE_DROITE:OCR1A        = 102             ; OCR1B	     = 128             ; 
if (Position_Robot == CENTRE_3) EtatCdeMot = CDE_CENTRE3;
else if (Position_Robot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS;
else EtatCdeMot = CDE_DROITE;
break;   

case CDE_DROITE_PLUS:OCR1A        = 102             ; OCR1B	     = 153		 ;
if (Position_Robot == GAUCHE) EtatCdeMot = CDE_DROITE; 
else if (Position_Robot == HORS_LIGNE) EtatCdeMot = HORS_LIGNE_DROITE;
else EtatCdeMot = CDE_DROITE_PLUS;
break;  

case HORS_LIGNE_DROITE:OCR1A        = 128             ; OCR1B	     = 204		 ;
if (Position_Robot == GAUCHE_PLUS) EtatCdeMot = CDE_DROITE_PLUS; 
else EtatCdeMot = HORS_LIGNE_DROITE;
break; 

case CDE_GAUCHE: OCR1A        = 128             ; OCR1B	     = 102             ; 
if (Position_Robot == CENTRE_3) EtatCdeMot = CDE_CENTRE3;
else if (Position_Robot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS;
else EtatCdeMot = CDE_GAUCHE;
break;  

case CDE_GAUCHE_PLUS: OCR1A        = 153		 ; OCR1B	     = 102             ; 
if (Position_Robot == DROITE) EtatCdeMot = CDE_GAUCHE;
else if (Position_Robot == HORS_LIGNE) EtatCdeMot = HORS_LIGNE__GAUCHE;
else EtatCdeMot = CDE_GAUCHE_PLUS;
break; 

case HORS_LIGNE__GAUCHE:OCR1A        = 204		 ; OCR1B	     = 128             ;
if (Position_Robot == DROITE_PLUS) EtatCdeMot = CDE_GAUCHE_PLUS; 
else EtatCdeMot = HORS_LIGNE__GAUCHE;   
break;

default : EtatCdeMot = CDE_CENTRE3;

}

delay_us(704     ); 

}
} 

void Arret_Moteurs()
{
TCCR1A = 0x00; 
TCCR1B = 0x00; 
PORTB=0x0B;     
} 

void Active_Timer()
{       
TCCR1A=0xA3;
TCCR1B=0x03;
} 
